# MiloDB by FrozenWolf is marked with CC0 1.0.
# To view a copy of this license, visit http://creativecommons.org/publicdomain/zero/1.0
from collections.abc import Iterable
from prompt_toolkit.completion import CompleteEvent, Completer, Completion # type: ignore
from prompt_toolkit.document import Document # type: ignore
from milodb_common.input.input_suggester import InputSuggester

class TabCompleter(Completer):
    def __init__(self, input_suggester: InputSuggester) -> None:
        self._input_suggester: InputSuggester = input_suggester

    def get_completions(self, document: Document, complete_event: CompleteEvent) -> Iterable[Completion]:
        return self._input_suggester.get_possible_completions(document.text, document.cursor_position_col)
